package de.wwwu.awolf.presenter.algorithms;

import de.wwwu.awolf.model.Line;

import java.util.concurrent.Callable;

/**
 * Implementierung verschiedener Algorithmen zur Berechnung von Ausgleichsgeraden.
 *
 * @Author: Armin Wolf
 * @Email: a_wolf28@uni-muenster.de
 * @Date: 28.05.2017.
 */
public interface Algorithm extends Callable<Line> {

    /**
     * Startet die Berechnung des jeweiligen Algorithmus.
     */
    @Override
    Line call();


    enum Type {
        LMS,
        RM,
        TS,
        NAIV_LMS,
        NAIV_RM,
        NAIV_TS
    }
}
