package de.wwwu.awolf.presenter.util;

import de.wwwu.awolf.presenter.Presenter;
import org.apache.log4j.AppenderSkeleton;
import org.apache.log4j.spi.LoggingEvent;
import org.powermock.core.classloader.annotations.PowerMockIgnore;

@PowerMockIgnore("org.apache.log4j.Appender")
public class GuiAppender extends AppenderSkeleton {

    private final Presenter presenter = Presenter.getInstance();

    @Override
    protected void append(LoggingEvent logEvent) {

        if (logEvent.getLevel().toInt() >= 40000) {
            presenter.getView().logError(logEvent.getRenderedMessage());
        } else if (logEvent.getLevel().toInt() == 30000) {
            presenter.getView().logWarning(logEvent.getRenderedMessage());
        } else if (logEvent.getLevel().toInt() > 10000 && logEvent.getLevel().toInt() < 30000){
            presenter.getView().logInfo(logEvent.getMessage().toString());
        }
    }

    @Override
    public void close() {

    }

    @Override
    public boolean requiresLayout() {
        return false;
    }
}
